<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Document sans titre</title>
<link href="../styles.css" rel="stylesheet" type="text/css" />
</head>
<body>
<?php
// Fonction qui télécharge puis affiche les catégories dans des listes déroulmantes dynamiques. Elle prend en parametre une session ebay.
function GetCategorie($ebaySession)
{
	// Modifie le verbe de la session
	$ebaySession->setVerb('GetCategories');
	
	// Nom du fichier qui contiendra l'arbre des catégories
	$filename='categories/Arbre_Categorie.xml';	
	
	// Variable récupérant l'arbre des catégories et qui va permettre de le parser
	$catTreeDoc = NULL;
	
		// On vérifie si le fichier existe
		if(file_exists($filename))
		{	
			// S'il existe, on vérifie la version actuelle du site pour voir si la version de notre fichier xml est la plus récente
			
			//Recupère la version actuelle du site
			$onlineVersion = getOnlineTreeVersion($ebaySession->siteID, $ebaySession->requestToken,$ebaySession,$filename);
			
			//On récupère la version de notre fichier xml
			$catTreeDoc = new DOMDocument();
			$catTreeDoc->load($filename);
			$localVersionNode = $catTreeDoc->getElementsByTagName('CategoryVersion');
			$localVersion = $localVersionNode->item(0)->nodeValue;
			
			//Si la version n'est pas la même, on récupère un nouvel arbre;
			if( $onlineVersion != $localVersion)
			{	
				
				// On crée l'arbre
				$catTreeDoc = getEntireCategoryTree($ebaySession->siteID, $ebaySession->requestToken, $ebaySession,$filename);
							
			}
		}
		else
		{
			//S'il n'existe pas, on appelle une fonction qui télécharge l'arbre et le sauvegarde dans le fichier			
			$catTreeDoc = getEntireCategoryTree($ebaySession->siteID, $ebaySession->requestToken, $ebaySession,$filename);
		}
}
	
	
//______________________________________________________________________________________________________________________________________//	
	
	/**	getEntireCategoryTree
	Retourne l'arbre entier des catégories eBay et le sauve dans un fichier
*/
function getEntireCategoryTree($siteID, $userToken, $session,$filename)
{
	//Construit une requète XML pour demander de retourner l'arbre entier
	$requestXmlBody = '<?xml version="1.0" encoding="utf-8" ?>';
	$requestXmlBody .= '<GetCategoriesRequest xmlns="urn:ebay:apis:eBLBaseComponents">';
	$requestXmlBody .= "<RequesterCredentials><eBayAuthToken>".$userToken."</eBayAuthToken></RequesterCredentials>"; //Clé de l'utilisateur
	$requestXmlBody .= "<DetailLevel>ReturnAll</DetailLevel>"; //pour recupérer l'arbre entier
	$requestXmlBody .= "<Item><Site>".$siteID."</Site></Item>";//Pour envoyer sur le site du pays désiré
	$requestXmlBody .= "<ViewAllNodes>1</ViewAllNodes>"; //Donne tout les noeuds 
	$requestXmlBody .= '</GetCategoriesRequest>';	
	
	// Envoi la requête xml
	$responseXml = $session->sendHttpRequest($requestXmlBody);
	if(stristr($responseXml, 'HTTP 404') || $responseXml == '')
		die('Erreur envoie de requète');
	
	//On créé un DOMdocument xml avec la réponse de la requète 
	$responseDoc = new DomDocument();
	$responseDoc->loadXML($responseXml);
	
	//On sauvegarde dans le fichier xml le document
	$responseDoc->save($filename);
	
	//On retourne le DOMDocument
	return $responseDoc;
}	
	

//____________________________________________________________________________________________________________________________//

	/**	getOnlineTreeVersion
	Retourne la version actuelle du site
*/
function getOnlineTreeVersion($siteID, $userToken,$session, $filename)
{
	//Construit la requète xml
	$requestXmlBody = '<?xml version="1.0" encoding="utf-8" ?>';
	$requestXmlBody .= '<GetCategoriesRequest xmlns="urn:ebay:apis:eBLBaseComponents">';
	$requestXmlBody .= "<RequesterCredentials><eBayAuthToken>$userToken</eBayAuthToken></RequesterCredentials>";
	$requestXmlBody .= "<ViewAllNodes>0</ViewAllNodes>";
	$requestXmlBody .= '</GetCategoriesRequest>';
	
	
	// Envoie la requète
	$responseXml = $session->sendHttpRequest($requestXmlBody);
	
	// Vérifie si la requête est valide
	if(stristr($responseXml, 'HTTP 404') || $responseXml == '')
		die('<P>Erreur envoie requète');
	
	// On crée un DOM Document avec la réponse
	$responseDoc = new DomDocument();
	$responseDoc->loadXML($responseXml);
	
	// On récupère la version de la requète
	$version = $responseDoc->getElementsByTagName('CategoryVersion');
	
	// retourne la version
	return $version->item(0)->nodeValue;
}

function GetCategorie2S($ebaySession)
{

	//Créer une session
	
	$ebaySession->setVerb('GetCategory2CS');
	$filename='categories/CatMap.xml';	
	
	$catMapDoc = NULL;
	
	
	if(!file_exists($filename))
	{   //Si le fichier n'existe pas, on récupère l'arbre entier
		
		$catMapDoc = getEntireCategoryMap($ebaySession->devID, $ebaySession->appID, $ebaySession->certID, $ebaySession->compatLevel,
												$ebaySession->siteID, $ebaySession->requestToken, $ebaySession->serverUrl,$ebaySession,$filename);
		
	}
	else
	{
		//Récupère la version online des catégories
		$onlineVersion = getOnlineMapVersion($ebaySession->devID, $ebaySession->appID, $ebaySession->certID, $ebaySession->compatLevel,
												$ebaySession->siteID, $ebaySession->requestToken, $ebaySession->serverUrl,$ebaySession);
		//Récupère notre version des catégories
		$catMapDoc = new DOMDocument();
		$catMapDoc->load($filename);
		
		$attSysVersionNode = $catMapDoc->getElementsByTagName('AttributeSystemVersion');
		
		$localVersion = $attSysVersionNode->item(0)->nodeValue;
		
		//Si les versions diffèrent
		if( $onlineVersion != $localVersion)
		{
			//On récupère l'arbre entier			
			$catMapDoc = getEntireCategoryMap($ebaySession->devID, $ebaySession->appID, $ebaySession->certID, $ebaySession->compatLevel,
												$ebaySession->siteID, $ebaySession->requestToken, $ebaySession->serverUrl,$ebaySession,$filename);
		}
	}
	
}
	
	/**	getEntireCategoryMap
	Recupère l'arbre entier des catégories
*/
function getEntireCategoryMap($devID, $appID, $certID, $compatabilityLevel, $siteID, $userToken, $serverUrl,$session,$filename)
{
	//Construit la requète xml
	$requestXmlBody = '<?xml version="1.0" encoding="utf-8" ?>';
	$requestXmlBody .= '<GetCategory2CSRequest xmlns="urn:ebay:apis:eBLBaseComponents">';
	$requestXmlBody .= "<RequesterCredentials><eBayAuthToken>".$userToken."</eBayAuthToken></RequesterCredentials>";
	$requestXmlBody .= "<DetailLevel>ReturnAll</DetailLevel>"; //get the entire Map
	$requestXmlBody .= "<Item><Site>".$siteID."</Site></Item>";
	$requestXmlBody .= '</GetCategory2CSRequest>';
	
	
    
    
	//Envoie la requète
	$responseXml = $session->sendHttpRequest($requestXmlBody);
	if(stristr($responseXml, 'HTTP 404') || $responseXml == '')
		die('<P>Error sending request');
	
	
	$responseDoc = new DomDocument();
	$responseDoc->loadXML($responseXml);
	
	//Save l'arbre dans un fichier XML
	$responseDoc->save($filename);
	
	//retourne la reponse
	return $responseDoc;
}


/**	getOnlineMapVersion
	Retourn la version des catégories
*/
function getOnlineMapVersion($devID, $appID, $certID, $compatabilityLevel, $siteID, $userToken, $serverUrl,$session)
{
	//Construit la requète xml
	$requestXmlBody = '<?xml version="1.0" encoding="utf-8" ?>';
	$requestXmlBody .= '<GetCategory2CSRequest xmlns="urn:ebay:apis:eBLBaseComponents">';
	$requestXmlBody .= "<RequesterCredentials><eBayAuthToken>$userToken</eBayAuthToken></RequesterCredentials>";
	$requestXmlBody .= '</GetCategory2CSRequest>';
	    
        
	//Envoie la requête xml
	$responseXml = $session->sendHttpRequest($requestXmlBody);
	if(stristr($responseXml, 'HTTP 404') || $responseXml == '')
		die('<P>Error sending request');
	
	
	$responseDoc = new DOMDocument();
	$responseDoc->loadXML($responseXml);
	
	//Parse le document pour récupérer la version
	$version = $responseDoc->getElementsByTagName('AttributeSystemVersion');
	
	//retourne la version
	return $version->item(0)->nodeValue;
}
?>
</body>
</html>