
<?php require_once('config/eBaySession.php') ?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<TITLE>Categories</TITLE>
<link href="../styles.css" rel="stylesheet" type="text/css" />
</HEAD>
<BODY>

<?php

function GetCategorie2S($ebaySession)
{

	//Crer une session
	
	$ebaySession->setVerb('GetCategory2CS');
	$filename='categories/CatMap.xml';	
	
	$catMapDoc = NULL;
	
	
	if(!file_exists($filename))
	{   //file does not exists -> request and save
		
		$catMapDoc = getEntireCategoryMap($ebaySession->devID, $ebaySession->appID, $ebaySession->certID, $ebaySession->compatLevel,
												$ebaySession->siteID, $ebaySession->requestToken, $ebaySession->serverUrl,$ebaySession,$filename);
		
	}
	else
	{
		//get online version number
		$onlineVersion = getOnlineMapVersion($ebaySession->devID, $ebaySession->appID, $ebaySession->certID, $ebaySession->compatLevel,
												$ebaySession->siteID, $ebaySession->requestToken, $ebaySession->serverUrl,$ebaySession);
		//get local version number
		$catMapDoc = new DOMDocument();
		$catMapDoc->load($filename);
		
		$attSysVersionNode = $catMapDoc->getElementsByTagName('AttributeSystemVersion');
		
		$localVersion = $attSysVersionNode->item(0)->nodeValue;
		
		//if version numbers differ
		if( $onlineVersion != $localVersion)
		{
			//download and save the category map
			
			$catMapDoc = getEntireCategoryMap($ebaySession->devID, $ebaySession->appID, $ebaySession->certID, $ebaySession->compatLevel,
												$ebaySession->siteID, $ebaySession->requestToken, $ebaySession->serverUrl,$ebaySession,$filename);
		}
	}
	
}
	
	/**	getEntireCategoryMap
	Retrieves the entire category Map from eBay API and saves it locally in an XML file
*/
function getEntireCategoryMap($devID, $appID, $certID, $compatabilityLevel, $siteID, $userToken, $serverUrl,$session,$filename)
{
	//Build the request Xml string
	$requestXmlBody = '<?xml version="1.0" encoding="utf-8" ?>';
	$requestXmlBody .= '<GetCategory2CSRequest xmlns="urn:ebay:apis:eBLBaseComponents">';
	$requestXmlBody .= "<RequesterCredentials><eBayAuthToken>".$userToken."</eBayAuthToken></RequesterCredentials>";
	$requestXmlBody .= "<DetailLevel>ReturnAll</DetailLevel>"; //get the entire Map
	$requestXmlBody .= "<Item><Site>".$siteID."</Site></Item>";
	$requestXmlBody .= '</GetCategory2CSRequest>';
	
	
    
    
	//send the request
	$responseXml = $session->sendHttpRequest($requestXmlBody);
	if(stristr($responseXml, 'HTTP 404') || $responseXml == '')
		die('<P>Error sending request');
	
	//Xml string is parsed and creates a DOM Document object
	$responseDoc = new DomDocument();
	$responseDoc->loadXML($responseXml);
	
	//save the tree to local file
	$responseDoc->save($filename);
	
	//return the DOM Document
	return $responseDoc;
}


/**	getOnlineMapVersion
	Returns the Version number of the Category Map that is currently available online
*/
function getOnlineMapVersion($devID, $appID, $certID, $compatabilityLevel, $siteID, $userToken, $serverUrl,$session)
{
	//Build the request Xml string
	$requestXmlBody = '<?xml version="1.0" encoding="utf-8" ?>';
	$requestXmlBody .= '<GetCategory2CSRequest xmlns="urn:ebay:apis:eBLBaseComponents">';
	$requestXmlBody .= "<RequesterCredentials><eBayAuthToken>$userToken</eBayAuthToken></RequesterCredentials>";
	$requestXmlBody .= '</GetCategory2CSRequest>';
	    
        
	//send the request
	$responseXml = $session->sendHttpRequest($requestXmlBody);
	if(stristr($responseXml, 'HTTP 404') || $responseXml == '')
		die('<P>Error sending request');
	
	//Xml string is parsed and creates a DOM Document object
	$responseDoc = new DOMDocument();
	$responseDoc->loadXML($responseXml);
	
	//get the version name
	$version = $responseDoc->getElementsByTagName('AttributeSystemVersion');
	
	//return the version
	return $version->item(0)->nodeValue;
}
?>

</BODY>
</HTML>

