<?php
	

class eBaySession
{
	//Identifiant de l'utilisateur
	public $requestToken;
	//Identifiant de dveloppeur
	public $devID;
	//Id d'application
	public $appID;
	//Id de certification
	public $certID;
	//Url du serveur
	public $serverUrl;
	//Niveau de compatibilite
	public $compatLevel;
	//Id du site
	public $siteID;
	//Nom de la requte
	public $verb;
	//Taille de la requte
	public $boundary;
	
	//Constructeur de eBaySession
	public function __construct($userRequestToken, $developerID, $applicationID, $certificateID, $serverUrl,
								$compatabilityLevel, $siteToUseID)
	{
		$this->requestToken = $userRequestToken;
		$this->devID = $developerID;
		$this->appID = $applicationID;
		$this->certID = $certificateID;
		$this->compatLevel = $compatabilityLevel;
		$this->siteID = $siteToUseID;
		$this->serverUrl = $serverUrl;	
		$this->boundary= "MIME_boundary";
	}
	
	//Affiche les informations de l'eBaySession
	public function affiche()
	{
		echo $this->requestToken;
		echo "<br/>";
	 echo $this->devID;
	 echo "<br/>";
	 echo $this->appID;
	 echo "<br/>";
	 echo $this->certID;
	 echo "<br/>";
	 echo $this->serverUrl;
	 echo "<br/>";
	 echo $this->compatLevel;
	 echo "<br/>";
	 echo $this->boundary;
	 echo "<br/>";
	 echo $this->siteID;
	 echo "<br/>";
	 echo $this->verb;
	 echo "<br/>";
	}
	
	/**
		Donne le nom de la requte
	*/
	public function setVerb($callName)
	{
		$this->verb=$callName;
	}
	
	//Mthode qui envoie la requte au serveur
	public function sendHttpRequest($requestBody)
	{
		//Construit le header
		$headers = $this->buildEbayHeaders($requestBody);
		
		//initialise une session CURL
		$connection = curl_init();
		//Donne l'adresse du serveur
		curl_setopt($connection, CURLOPT_URL, $this->serverUrl);
		
		//Vrification de l'ouverture de la connection
		curl_setopt($connection, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($connection, CURLOPT_SSL_VERIFYHOST, 0);
		
		//Mettre le header dans la session
		curl_setopt($connection, CURLOPT_HTTPHEADER, $headers);
		
		//Donne la mthode POST
		curl_setopt($connection, CURLOPT_POST, 1);
		
		//Mettre la requte dans la session
		curl_setopt($connection, CURLOPT_POSTFIELDS, $requestBody);
		curl_setopt($connection, CURLOPT_RETURNTRANSFER, 1);
		
		//Envoie la requte
		$response = curl_exec($connection);
		
		//Ferme la connection
		curl_close($connection);
		
		//retourne la rponse
		return $response;
	}
	
	//Envoie une image
	public function sendHttpRequestImage($requestBody)
	{        
		//Construit le header
        $headers = array (
            'Content-Type: multipart/form-data; boundary=' . $this->boundary,
            'Content-Length: ' . strlen($requestBody),
	    'X-EBAY-API-COMPATIBILITY-LEVEL: ' . $this->compatLevel,  // API version
			
	    'X-EBAY-API-DEV-NAME: ' . $this->devID,     //set the keys
	    'X-EBAY-API-APP-NAME: ' . $this->appID,
	    'X-EBAY-API-CERT-NAME: ' . $this->certID,

            'X-EBAY-API-CALL-NAME: ' . $this->verb,		// call to make	
	    'X-EBAY-API-SITEID: ' . $this->siteID,      // US = 0, DE = 77...
        );
	//Initialiser la session CURL
	$connection = curl_init();
	//Configurer la session CURL
	curl_setopt($connection, CURLOPT_URL, $this->serverUrl);
        curl_setopt($connection, CURLOPT_TIMEOUT, 30 );
	curl_setopt($connection, CURLOPT_SSL_VERIFYPEER, 0);
	curl_setopt($connection, CURLOPT_SSL_VERIFYHOST, 0);
	curl_setopt($connection, CURLOPT_HTTPHEADER, $headers);
	curl_setopt($connection, CURLOPT_POST, 1);
	curl_setopt($connection, CURLOPT_POSTFIELDS, $requestBody);
	curl_setopt($connection, CURLOPT_RETURNTRANSFER, 1); 
        curl_setopt($connection, CURLOPT_FAILONERROR, 0 );
        curl_setopt($connection, CURLOPT_FOLLOWLOCATION, 1 );
        //curl_setopt($connection, CURLOPT_HEADER, 1 );           // Uncomment these for debugging
        //curl_setopt($connection, CURLOPT_VERBOSE, true);        // Display communication with serve
        curl_setopt($connection, CURLOPT_USERAGENT, 'ebatns;xmlstyle;1.0' );
        curl_setopt($connection, CURLOPT_HTTP_VERSION, 1 );       // HTTP version must be 1.0
	$response = curl_exec($connection);
        
        if ( !$response ) {
            print "curl error " . curl_errno($connection ) . "\n";
        }
	//Ferme la connection 
	curl_close($connection);
	return $response;
    } 
	
	
	
	
	
	
	/**	Construit le header
	*/
	private function buildEbayHeaders($requestBody)
	{
		$headers = array (
			
			
			'X-EBAY-API-COMPATIBILITY-LEVEL: ' . $this->compatLevel,
			
			
			'X-EBAY-API-DEV-NAME: ' . $this->devID,
			'X-EBAY-API-APP-NAME: ' . $this->appID,
			'X-EBAY-API-CERT-NAME: ' . $this->certID,
			'X-EBAY-API-CALL-NAME: ' . $this->verb,			
			'X-EBAY-API-SITEID: ' . $this->siteID,
		);
		
		return $headers;
	}
	
	
}
?>